package StateMLplus.SMExample.Ts2FOO;
public class SMExample_Simulator implements SMExample_finFSMinterface{
	 int opc;
	 static boolean continuar;
	 SMExample_FSM fsmObj;

	 /*SE CREA EL CONSTRUCTOR*/
	 public SMExample_Simulator(){
		 continuar = true;
		 fsmObj = new SMExample_FSM(this);
	 }

	 /*FUNCION QUE NOTIFICARA */
	 public void notifyEnd(){
		 continuar = false;
	 }
	 public void fire_transition ( int opc ){
	 switch(opc){
		 case 1 : fsmObj.fireTransition(SMExample_FSM.transition.start);
			 break;
		 case 2 : fsmObj.fireTransition(SMExample_FSM.transition.processData);
			 break;
		 case 3 : fsmObj.fireTransition(SMExample_FSM.transition.dataOK);
			 break;
		 case 4 : fsmObj.fireTransition(SMExample_FSM.transition.errorInit);
			 break;
		 case 5 : fsmObj.fireTransition(SMExample_FSM.transition.errorIdle);
			 break;
		 case 6 : fsmObj.fireTransition(SMExample_FSM.transition.errorProcessing);
			 break;
		 case 7 : fsmObj.fireTransition(SMExample_FSM.transition.restart);
			 break;
		 case 8 : fsmObj.fireTransition(SMExample_FSM.transition.check);
			 break;
		 case 9: fsmObj.getEstadosActualesToString();
			 break;
		 default :
			 break;
		 } //Fin switch
	 } // Fin fire_transition

public static void main(String args[]){
	SMExample_Simulator sm = new SMExample_Simulator();
	 System.out.println ("------------------------------------------" );
	 System.out.println (" Bienvenido a SMExample_Simulator" );
	 while(continuar){
	 System.out.println ("------------------------------------------" );
		 System.out.println ("   1.- start" );
		 System.out.println ("   2.- processData" );
		 System.out.println ("   3.- dataOK" );
		 System.out.println ("   4.- errorInit" );
		 System.out.println ("   5.- errorIdle" );
		 System.out.println ("   6.- errorProcessing" );
		 System.out.println ("   7.- restart" );
		 System.out.println ("   8.- check" );
		 System.out.println ("   9.- Mostrar estados actuales en pantalla");
	 System.out.println ("------------------------------------------" );
		 System.out.println ("   0.- Finalizar Simulador" );
	 System.out.println ("------------------------------------------" );
		 System.out.print ("   Selecciona transicin a disparar (0-9):  ");
		 int elec = Teclado.readInt(  );
	 System.out.println ("------------------------------------------" );
		 if (elec == 0){ 
			 System.out.println("Ha elegido finalizar el simulador.");
			 continuar = false; //Si opc=0, salir del bucle infinito 
 			 } 
		 sm.fire_transition ( elec );
	 } // Fin while
 } // Fin main 

} //Fin class
