package StateMLplus.SMExample.patronEstado;
public class SMExample_Simulator implements SMExample_finFSMinterface{
	 int opc;
	 static boolean continuar;
	 SMExample_FSM FSM;

	 /*SE CREA EL CONSTRUCTOR*/
	 public SMExample_Simulator(){
		 FSM = new SMExample_FSM(this);
		 continuar = true;
	}

	/*Funcion que notificar el fin de la mquina de estados*/
	 public void notifyEnd(){
		 continuar = false; //Para finalizar el bucle infinito, se pone su condicin a false
	 }
	 public void fire_transition ( int opc ) {
	 switch(opc){
			 case 1 : FSM.start();
					 break;
			 case 2 : FSM.processData();
					 break;
			 case 3 : FSM.dataOK();
					 break;
			 case 4 : FSM.errorInit();
					 break;
			 case 5 : FSM.errorIdle();
					 break;
			 case 6 : FSM.errorProcessing();
					 break;
			 case 7 : FSM.restart();
					 break;
			 case 8 : FSM.check();
					 break;
			 case 9 : FSM.getEstadosActualesToString();
					 break;
			 default : break;
		 } //Fin switch
	 } // Fin fire_transition

public static void main(String args[]){
	SMExample_Simulator sm = new SMExample_Simulator();
	 System.out.println ("------------------------------------------" );
	 System.out.println (" Bienvenido a SMExample_Simulator" );
	 while(continuar){
	 System.out.println ("------------------------------------------" );
		 System.out.println ("   1.- start" );
		 System.out.println ("   2.- processData" );
		 System.out.println ("   3.- dataOK" );
		 System.out.println ("   4.- errorInit" );
		 System.out.println ("   5.- errorIdle" );
		 System.out.println ("   6.- errorProcessing" );
		 System.out.println ("   7.- restart" );
		 System.out.println ("   8.- check" );
		 System.out.println ("   9.- Mostrar estados actuales en pantalla");
	 System.out.println ("------------------------------------------" );
		 System.out.println ("   0.- Finalizar Simulador" );
	 System.out.println ("------------------------------------------" );
		 System.out.print ("   Selecciona transicin a disparar (0-9):  ");
		 int elec = Teclado.readInt(  );
	 System.out.println ("------------------------------------------" );
		 if (elec == 0){ 
			 System.out.println("Ha elegido finalizar el simulador.");
			 continuar = false; //Si opc=0, salir del bucle infinito 
 			 } 
		 sm.fire_transition ( elec );
	 } // Fin while
 } // Fin main 

} //Fin class
