package StateMLplus.SMExample2.Ts2FsOO;
public class SMExample2_Simulator implements SMExample2_finFSMinterface{
	 int opc;
	 static boolean continuar;
	 SMExample2_FSM FSM;

	 /*SE CREA EL CONSTRUCTOR*/
	 public SMExample2_Simulator(){
		 FSM = new SMExample2_FSM(this);
		 continuar = true;
	}

	/*Funcion que notificar el fin de la mquina de estados*/
	 public void notifyEnd(){
		 continuar = false; //Para finalizar el bucle infinito, se pone su condicin a false
	 }
	 public void fire_transition ( int opc ) {
	 switch(opc){
			 case 1 : FSM.start();
					 break;
			 case 2 : FSM.errorInit();
					 break;
			 case 3 : FSM.errorWorking();
					 break;
			 case 4 : FSM.restart();
					 break;
			 case 5 : FSM.finish();
					 break;
			 case 6 : FSM.check();
					 break;
			 case 7 : FSM.processData();
					 break;
			 case 8 : FSM.dataOK();
					 break;
			 case 9 : FSM.getEstadosActualesToString();
					 break;
			 default : break;
		 } //Fin switch
	 } // Fin fire_transition

public static void main(String args[]){
	SMExample2_Simulator sm = new SMExample2_Simulator();
	 System.out.println ("------------------------------------------" );
	 System.out.println (" Bienvenido a SMExample2_Simulator" );
	 while(continuar){
	 System.out.println ("------------------------------------------" );
		 System.out.println ("   1.- start" );
		 System.out.println ("   2.- errorInit" );
		 System.out.println ("   3.- errorWorking" );
		 System.out.println ("   4.- restart" );
		 System.out.println ("   5.- finish" );
		 System.out.println ("   6.- check" );
		 System.out.println ("   7.- processData" );
		 System.out.println ("   8.- dataOK" );
		 System.out.println ("   9.- Mostrar estados actuales en pantalla");
	 System.out.println ("------------------------------------------" );
		 System.out.println ("   0.- Finalizar Simulador" );
	 System.out.println ("------------------------------------------" );
		 System.out.print ("   Selecciona transicin a disparar (0-9):  ");
		 int elec = Teclado.readInt(  );
	 System.out.println ("------------------------------------------" );
		 if (elec == 0){ 
			 System.out.println("Ha elegido finalizar el simulador.");
			 continuar = false; //Si opc=0, salir del bucle infinito 
 			 } 
		 sm.fire_transition ( elec );
	 } // Fin while
 } // Fin main 

} //Fin class
