package StateMLplus.SMExample2.patronEstado;
class SMExample2_State{

	 /*SE RECOGE LOS POSIBLES ESTADOS Y TRANSICIONES*/
	 enum estado { Init, Working, Idle, Processing, Error, Fin};

	 /*DECLARACION DE VARIABLES.
	 Se almacenar el nombre del estado y el nombre del estado actual de cada region*/
	 estado name;

	/*Se utiliza un objeto de la clase FSM, para actualizar los estados actuales de cada regin*/
	 SMExample2_FSM theFSM;


	/*Se utiliza un objeto de la clase fire, para simular el disparo de las transiciones*/
	 SMExample2_fireTransition fire = new SMExample2_fireTransition();

	 estado getEstado(){
		 return name;
	}

	 /*ACCIONES DE LOS ESTADOS*/

	 /*No se declaran como funciones abstractas,porque 
	 hay estados que no realizarn todas las acciones*/
	 void onEntry(){}
	 void ejecutar(){}
	 void onExit(){}

	 /*LANZAMIENTO DE TRANSICIONES POR PARTE DE LOS ESTADOS*/
	 void start(){}
	 void errorInit(){}
	 void errorWorking(){}
	 void restart(){}
	 void finish(){}
	 void check(){}
	 void processData(){}
	 void dataOK(){}
}
