package StateMLplus.SMExample3.Ts2FOO;
public class SMExample3_Simulator implements SMExample3_finFSMinterface{
	 int opc;
	 static boolean continuar;
	 SMExample3_FSM fsmObj;

	 /*SE CREA EL CONSTRUCTOR*/
	 public SMExample3_Simulator(){
		 continuar = true;
		 fsmObj = new SMExample3_FSM(this);
	 }

	 /*FUNCION QUE NOTIFICARA */
	 public void notifyEnd(){
		 continuar = false;
	 }
	 public void fire_transition ( int opc ){
	 switch(opc){
		 case 1 : fsmObj.fireTransition(SMExample3_FSM.transition.go);
			 break;
		 case 2 : fsmObj.fireTransition(SMExample3_FSM.transition.contCmd);
			 break;
		 case 3 : fsmObj.fireTransition(SMExample3_FSM.transition.error);
			 break;
		 case 4 : fsmObj.fireTransition(SMExample3_FSM.transition.done);
			 break;
		 case 5 : fsmObj.fireTransition(SMExample3_FSM.transition.abort);
			 break;
		 case 6 : fsmObj.fireTransition(SMExample3_FSM.transition.sysRecovered);
			 break;
		 case 7 : fsmObj.fireTransition(SMExample3_FSM.transition.end);
			 break;
		 case 8 : fsmObj.fireTransition(SMExample3_FSM.transition.reStart);
			 break;
		 case 9 : fsmObj.fireTransition(SMExample3_FSM.transition.initialized);
			 break;
		 case 10 : fsmObj.fireTransition(SMExample3_FSM.transition.oriented);
			 break;
		 case 11 : fsmObj.fireTransition(SMExample3_FSM.transition.armInitialized);
			 break;
		 case 12 : fsmObj.fireTransition(SMExample3_FSM.transition.calcDone);
			 break;
		 case 13 : fsmObj.fireTransition(SMExample3_FSM.transition.movementDetect);
			 break;
		 case 14: fsmObj.getEstadosActualesToString();
			 break;
		 default :
			 break;
		 } //Fin switch
	 } // Fin fire_transition

public static void main(String args[]){
	SMExample3_Simulator sm = new SMExample3_Simulator();
	 System.out.println ("------------------------------------------" );
	 System.out.println (" Bienvenido a SMExample3_Simulator" );
	 while(continuar){
	 System.out.println ("------------------------------------------" );
		 System.out.println ("   1.- go" );
		 System.out.println ("   2.- contCmd" );
		 System.out.println ("   3.- error" );
		 System.out.println ("   4.- done" );
		 System.out.println ("   5.- abort" );
		 System.out.println ("   6.- sysRecovered" );
		 System.out.println ("   7.- end" );
		 System.out.println ("   8.- reStart" );
		 System.out.println ("   9.- initialized" );
		 System.out.println ("   10.- oriented" );
		 System.out.println ("   11.- armInitialized" );
		 System.out.println ("   12.- calcDone" );
		 System.out.println ("   13.- movementDetect" );
		 System.out.println ("   14.- Mostrar estados actuales en pantalla");
	 System.out.println ("------------------------------------------" );
		 System.out.println ("   0.- Finalizar Simulador" );
	 System.out.println ("------------------------------------------" );
		 System.out.print ("   Selecciona transicin a disparar (0-14):  ");
		 int elec = Teclado.readInt(  );
	 System.out.println ("------------------------------------------" );
		 if (elec == 0){ 
			 System.out.println("Ha elegido finalizar el simulador.");
			 continuar = false; //Si opc=0, salir del bucle infinito 
 			 } 
		 sm.fire_transition ( elec );
	 } // Fin while
 } // Fin main 

} //Fin class
