package StateMLplus.SMExample3.patronEstado;
class SMExample3_MovingState extends SMExample3_State{
/*Se crea el constructor*/
	 SMExample3_MovingState (SMExample3_FSM fsm){
		 name = estado.Moving;
		 theFSM = fsm;
	 }

	 void onEntry(){
		 // -->>>> write code here...
		 System.out.println("		>>>> Ejecutando Moving_onEntry...");
	}
	 void ejecutar(){
		 // -->>>>> write code here...
		 System.out.println ("		>>>> Ejecutando Moving_do...");
		 System.out.println ("		>>>> Estado actual de topRegion : Moving");
	}
	  void onExit(){
		 // -->>>>> write code here...
		 System.out.println ("		>>>> Ejecutando Moving_onExit...");
	}
		//----------------------------------
	 void error(){
		 theFSM.armRegionActual.onExit();
		 theFSM.armRegionActual = null;
		 theFSM.toolRegionActual.onExit();
		 theFSM.toolRegionHistory = theFSM.toolRegionActual;
		 theFSM.toolRegionActual = null;
		 theFSM.topRegionActual.onExit();
		 fire.error_fire( );
		 theFSM.topRegionActual = theFSM.Error;
		 theFSM.topRegionActual.onEntry();
		 theFSM.topRegionActual.ejecutar();
	 }
		//----------------------------------
		//----------------------------------
	 void abort(){
		 theFSM.armRegionActual.onExit();
		 theFSM.armRegionActual = null;
		 theFSM.toolRegionActual.onExit();
		 theFSM.toolRegionHistory = theFSM.toolRegionActual;
		 theFSM.toolRegionActual = null;
		 theFSM.topRegionActual.onExit();
		 fire.abort_fire( );
		 theFSM.topRegionActual = theFSM.Ready;
		 theFSM.topRegionActual.onEntry();
		 theFSM.topRegionActual.ejecutar();
	 }
		//----------------------------------
}
