package StateMLplus.SMExample3.patronEstado;
class SMExample3_State{

	 /*SE RECOGE LOS POSIBLES ESTADOS Y TRANSICIONES*/
	 enum estado { Ready, Moving, InitTool, OrientedTool, PositionTool, InitArm, CalculatingPath, MovingArm, Error, Finished, EmergencyStop, End,join1};

	 /*DECLARACION DE VARIABLES.
	 Se almacenar el nombre del estado y el nombre del estado actual de cada region*/
	 estado name;

	/*Se utiliza un objeto de la clase FSM, para actualizar los estados actuales de cada regin*/
	 SMExample3_FSM theFSM;


	/*Se utiliza un objeto de la clase fire, para simular el disparo de las transiciones*/
	 SMExample3_fireTransition fire = new SMExample3_fireTransition();

	 estado getEstado(){
		 return name;
	}

	 /*ACCIONES DE LOS ESTADOS*/

	 /*No se declaran como funciones abstractas,porque 
	 hay estados que no realizarn todas las acciones*/
	 void onEntry(){}
	 void ejecutar(){}
	 void onExit(){}

	 /*LANZAMIENTO DE TRANSICIONES POR PARTE DE LOS ESTADOS*/
	 void go(){}
	 void contCmd(){}
	 void error(){}
	 void done(){}
	 void abort(){}
	 void sysRecovered(){}
	 void end(){}
	 void reStart(){}
	 void initialized(){}
	 void oriented(){}
	 void armInitialized(){}
	 void calcDone(){}
	 void movementDetect(){}
}
