package StateMLplus.SMExample.patronEstado;
class SMExample_IdleState extends SMExample_State{
/*Se crea el constructor*/
	 SMExample_IdleState (SMExample_FSM fsm){
		 name = estado.Idle;
		 theFSM = fsm;
	 }

	 void onEntry(){
		 // -->>>> write code here...
		 System.out.println("		>>>> Ejecutando Idle_onEntry...");
	}
	 void ejecutar(){
		 // -->>>>> write code here...
		 System.out.println ("		>>>> Ejecutando Idle_do...");
		 System.out.println ("		>>>> Estado actual de SM : Idle");
	}
	  void onExit(){
		 // -->>>>> write code here...
		 System.out.println ("		>>>> Ejecutando Idle_onExit...");
	}
		//----------------------------------
	 void processData(){
		 theFSM.SMActual.onExit();
		 fire.processData_fire( );
		 theFSM.SMActual = theFSM.Processing;
		 theFSM.SMActual.onEntry();
		 theFSM.SMActual.ejecutar();
	 }
		//----------------------------------
		//----------------------------------
	 void errorIdle(){
		 theFSM.SMActual.onExit();
		 fire.errorIdle_fire( );
		 theFSM.SMActual = theFSM.Error;
		 theFSM.SMActual.onEntry();
		 theFSM.SMActual.ejecutar();
	 }
		//----------------------------------
		//----------------------------------
	 void check(){
		 theFSM.SMActual.onExit();
		 fire.check_fire( );
		System.out.println("		>>>> Estado actual de SM : Idle");
	 }
		//----------------------------------
}
