package StateMLplus.SMExample3.patronEstado;
class SMExample3_ReadyState extends SMExample3_State{
/*Se crea el constructor*/
	 SMExample3_ReadyState (SMExample3_FSM fsm){
		 name = estado.Ready;
		 theFSM = fsm;
	 }

	 void onEntry(){
		 // -->>>> write code here...
		 System.out.println("		>>>> Ejecutando Ready_onEntry...");
	}
	 void ejecutar(){
		 // -->>>>> write code here...
		 System.out.println ("		>>>> Ejecutando Ready_do...");
		 System.out.println ("		>>>> Estado actual de topRegion : Ready");
	}
	  void onExit(){
		 // -->>>>> write code here...
		 System.out.println ("		>>>> Ejecutando Ready_onExit...");
	}
		//----------------------------------
	 void go(){
		 theFSM.topRegionActual.onExit();
		 fire.go_fire( );
		 theFSM.topRegionActual = theFSM.Moving;
		 theFSM.topRegionActual.onEntry();
		 theFSM.topRegionActual.ejecutar();
		 theFSM.toolRegionActual = theFSM.toolRegionHistory;
		 theFSM.toolRegionActual.onEntry();
		 theFSM.toolRegionActual.ejecutar();
		 theFSM.armRegionActual = theFSM.InitArm;
		 theFSM.armRegionActual.onEntry();
		 theFSM.armRegionActual.ejecutar();
	 }
		//----------------------------------
		//----------------------------------
	 void contCmd(){
		 theFSM.topRegionActual.onExit();
		 fire.contCmd_fire( );
		 theFSM.topRegionActual = theFSM.Moving;
		 theFSM.topRegionActual.onEntry();
		 theFSM.topRegionActual.ejecutar();
		//------------------------------
		 theFSM.toolRegionActual = theFSM.OrientedTool;
		 theFSM.toolRegionActual.onEntry();
		 theFSM.toolRegionActual.ejecutar();
		//------------------------------
		 theFSM.armRegionActual = theFSM.CalculatingPath;
		 theFSM.armRegionActual.onEntry();
		 theFSM.armRegionActual.ejecutar();
	 }
		//----------------------------------
}
