package StateMLplus.SMExample3.patronEstado;
public class SMExample3_Simulator implements SMExample3_finFSMinterface{
	 int opc;
	 static boolean continuar;
	 SMExample3_FSM FSM;

	 /*SE CREA EL CONSTRUCTOR*/
	 public SMExample3_Simulator(){
		 FSM = new SMExample3_FSM(this);
		 continuar = true;
	}

	/*Funcion que notificar el fin de la mquina de estados*/
	 public void notifyEnd(){
		 continuar = false; //Para finalizar el bucle infinito, se pone su condicin a false
	 }
	 public void fire_transition ( int opc ) {
	 switch(opc){
			 case 1 : FSM.go();
					 break;
			 case 2 : FSM.contCmd();
					 break;
			 case 3 : FSM.error();
					 break;
			 case 4 : FSM.done();
					 break;
			 case 5 : FSM.abort();
					 break;
			 case 6 : FSM.sysRecovered();
					 break;
			 case 7 : FSM.end();
					 break;
			 case 8 : FSM.reStart();
					 break;
			 case 9 : FSM.initialized();
					 break;
			 case 10 : FSM.oriented();
					 break;
			 case 11 : FSM.armInitialized();
					 break;
			 case 12 : FSM.calcDone();
					 break;
			 case 13 : FSM.movementDetect();
					 break;
			 case 14 : FSM.getEstadosActualesToString();
					 break;
			 default : break;
		 } //Fin switch
	 } // Fin fire_transition

public static void main(String args[]){
	SMExample3_Simulator sm = new SMExample3_Simulator();
	 System.out.println ("------------------------------------------" );
	 System.out.println (" Bienvenido a SMExample3_Simulator" );
	 while(continuar){
	 System.out.println ("------------------------------------------" );
		 System.out.println ("   1.- go" );
		 System.out.println ("   2.- contCmd" );
		 System.out.println ("   3.- error" );
		 System.out.println ("   4.- done" );
		 System.out.println ("   5.- abort" );
		 System.out.println ("   6.- sysRecovered" );
		 System.out.println ("   7.- end" );
		 System.out.println ("   8.- reStart" );
		 System.out.println ("   9.- initialized" );
		 System.out.println ("   10.- oriented" );
		 System.out.println ("   11.- armInitialized" );
		 System.out.println ("   12.- calcDone" );
		 System.out.println ("   13.- movementDetect" );
		 System.out.println ("   14.- Mostrar estados actuales en pantalla");
	 System.out.println ("------------------------------------------" );
		 System.out.println ("   0.- Finalizar Simulador" );
	 System.out.println ("------------------------------------------" );
		 System.out.print ("   Selecciona transicin a disparar (0-14):  ");
		 int elec = Teclado.readInt(  );
	 System.out.println ("------------------------------------------" );
		 if (elec == 0){ 
			 System.out.println("Ha elegido finalizar el simulador.");
			 continuar = false; //Si opc=0, salir del bucle infinito 
 			 } 
		 sm.fire_transition ( elec );
	 } // Fin while
 } // Fin main 

} //Fin class
